//+------------------------------------------------------------------+
//|                                               Bending_MA24H1.mq4 |
//|                                                     Pipkin Artem |
//|                           http://sites.google.com/site/forexsbs/ |
//+------------------------------------------------------------------+
#property copyright "Pipkin Artem"
#property link      "http://sites.google.com/site/forexsbs/"

//########################################################################
//--------------      ------------------#
#property indicator_chart_window                                       //#
//                                                                       #
//########################################################################



//########################################################################
//                                 
extern int       PERIOD        = 480;   // ,      (480 = 1 )
extern int       MATrendPeriod = 24;     //     H1 (24 = 1 )
extern int       Slayders      = 0;      // ,   "" MA
extern int       StepMin       = 0;      //  ,   ,      ( )
extern int       StepMax       = 300;    //  ,   ,       ( )
extern color     Color_D       = Red;    //     
extern color     Color_W       = Green;  // --//-- 
extern color     Color_M       = Yellow; // --//-- 
extern color     Color_Y       = Aqua;   // --//-- 

//########################################################################


//########################################################################
//                                       

int i, l, b, Stil, c, e;
double MA1, MA2, MA3;
color COLOR;
double LS;
double LP;
double max, min;
string S, P;

//                                      
//########################################################################


//+------------------------------------------------------------------+
//|  init()                                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
b=Bars; //     (      )
   for(int a=0; a<=l; a++) // ,   
     {
      ObjectDelete("Line"+a);
     }
   l=0; //  " "   
   
   ObjectDelete("TextS"); //       
   ObjectDelete("TextP"); //       
   
   
   for(i=1,c=0; i<=PERIOD; i++,c=0) //     
    {
    MA1=iMA(NULL,PERIOD_H1,MATrendPeriod,0,MODE_SMA,PRICE_MEDIAN,i); //     (i)
    MA2=iMA(NULL,PERIOD_H1,MATrendPeriod,0,MODE_SMA,PRICE_MEDIAN,i+1); //      1  (i+1)
    MA3=iMA(NULL,PERIOD_H1,MATrendPeriod,0,MODE_SMA,PRICE_MEDIAN,i+2); //      2  (i+2)
    
    if(i<=24) {COLOR=Color_D; Stil=5;}           //        
    if(i>24 && i<=120) {COLOR=Color_W; Stil=3;}  // --//-- 
    if(i>120 && i<=528) {COLOR=Color_M; Stil=2;} // --//-- 
    if(i>528) {COLOR=Color_Y; Stil=1;}           // --//-- 
    
    for(int e=0; e<=l; e++) //        Y ()
     {
      double ma2=NormalizeDouble(MA2,4);
      if(ma2==ObjectGet("Line"+e, OBJPROP_PRICE1)) c=c+1;
     }
    
    if(c==0 && ((MA1>MA2 && MA3>MA2) || (MA1<MA2 && MA3<MA2))) // ,    
      {
       MA2=NormalizeDouble(MA2,4); //     4-   
       if((MA2-Ask>StepMin*Point && MA2-Ask<StepMax*Point) || // ,  ,       
          (Bid-MA2>StepMin*Point && Bid-MA2<StepMax*Point))
           {
            Line();
            i=i+Slayders;
           }
      }
    }
  TextS(); //  ,   ""    
  TextP(); //  ,   ""    
//----
   return(0);
  }
//--------------------------------------------------------------------


//####################################################################
//                                 start()
int start()
  {
//----

if(Bars-b>1) init(); //       

for(i=0; i<=l; i++) {max=MathMax(max, ObjectGet("Line"+i, OBJPROP_PRICE1));} //   max  Y   

for(i=0; i<=l; i++) // ,    
{
if(Bid<ObjectGet("Line"+i, OBJPROP_PRICE1))
   {
    max=MathMin(max, ObjectGet("Line"+i, OBJPROP_PRICE1));
   }
if(Bid>ObjectGet("Line"+i, OBJPROP_PRICE1))
   {
    min=MathMax(min, ObjectGet("Line"+i, OBJPROP_PRICE1));
   }
}

ObjectSetText("TextS",": "+max,15,"Arial",Red); //     TextS()
ObjectSetText("TextP",": "+min,15,"Arial",Blue);    //     TextP()
i=0;
//----
   return(0);
  }
//                                  start()
//####################################################################


//+------------------------------------------------------------------+
//|  deinit()                                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int a=0; a<=l; a++)
     {
      ObjectDelete("Line"+a);
     }
    l=0;
   ObjectDelete("TextS");
   ObjectDelete("TextP");
   
   Print (" MA_MAXMIN_h1 ");
//----
   return(0);
  }
//+------------------------------------------------------------------+



//####################################################################
//                                   
//####################################################################

//+------------------------------------------------------------------+
//|  Line()                                                   |
//+------------------------------------------------------------------+

int Line()
   {
    ObjectCreate("Line"+l, OBJ_HLINE, 0,0,0,0,0);
    ObjectSet("Line"+l, OBJPROP_PRICE1, MA2);
    ObjectSet("Line"+l, OBJPROP_COLOR, COLOR);
    ObjectSet("Line"+l, OBJPROP_WIDTH, Stil);
    ObjectSet("Line"+l, OBJPROP_BACK, false);
    WindowRedraw();
    l=l+1;
   }

//-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  TextS()                                                   |
//+------------------------------------------------------------------+

int TextS()
   {
    ObjectCreate("TextS", OBJ_LABEL, 0, 0, 0);//  .
    ObjectSet("TextS", OBJPROP_CORNER, 1);    //  
    ObjectSet("TextS", OBJPROP_XDISTANCE, 2);//  
    ObjectSet("TextS", OBJPROP_YDISTANCE, 2);//  Y
   }

//-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  TextP()                                                   |
//+------------------------------------------------------------------+

int TextP()
   {
    ObjectCreate("TextP", OBJ_LABEL, 0, 0, 0);//  .
    ObjectSet("TextP", OBJPROP_CORNER, 3);    //  
    ObjectSet("TextP", OBJPROP_XDISTANCE, 2);//  
    ObjectSet("TextP", OBJPROP_YDISTANCE, 2);//  Y
   }

//-------------------------------------------------------------------+

//#######################################################################

